Introduction
------------

* What is Yii
* Upgrading from Version 1.1


Getting Started
---------------

* Overview
* Starting with Basic App
* Starting with Advanced App
* Starting from Scratch


Basic Concepts
--------------

* Object Properties
* Events
* Behaviors
* Object Configurations
* Class Autoloading
* Path Aliases
* Extensions
* Service Locator
* Dependency Injection Container


Key Components
--------------

* MVC Overview
* Entry Scripts
* Applications
* Controllers and Actions
* Views
* Models
* Action Filters
* Widgets
* Modules


Handling Requests
-----------------

* Request Lifecycle
* Bootstrapping
* Routing
* Requests
* Responses
* Sessions and Cookies
* URL Parsing and Generation


Collecting Input Data
---------------------

* Creating Forms
* Input Validation
* Uploading Files
* Handling Multiple Models


Presenting Data
---------------

* Data Formatting
* Pagination
* Sorting
* Data Providers
* Data Widgets
* Managing Assets


Working with Database
---------------------

* Data Access Objects - Connecting to a database, basic queries, transactions and schema manipulation
* Query Builder - Querying the database using a simple abstraction layer
* Active Record - The active record ORM, retrieving and manipulating records and defining relations
* Migrations
* Sphinx
* Redis
* MongoDB
* ElasticSearch


Security
--------

* Authentication
* Authorization
* Auth Clients
* Best Practices


Caching
-------

* Overview
* Data Caching
* Fragment and Page Caching
* HTTP Caching


RESTful Web Services
--------------------

* Quick Start
* API Endpoints
* Resources
* Data Formatting
* Authentication
* Rate Limiting
* Versioning
* Caching
* Error Handling
* Testing
* Documentation


Testing
-------

* Overview
* Unit Tests
* Functional Tests
* Acceptance Tests
* Fixtures


Extending Yii
-------------

* Creating Extensions
* Customizing Core Code
* Using 3rd-Party Libraries
* Using Yii in 3rd-Party Systems
* Using Yii 1.1 and 2.0 Together


Development Tools
-----------------

* Debug Toolbar and Debugger
* Generating Code using Gii
* Generating API Documentation
* Using Composer


Special Topics
--------------

* Console Commands
* Handling Errors
* Internationalization
* Logging
* Mailing
* Performance Tuning
* Template Engines
* Theming


Widgets
-------

* Overview
* GridView: link to demo page
* ListView: link to demo page
* DetailView: link to demo page
* ActiveForm: link to demo page
* ...other widgets...


Helpers
-------

* Overview
* Html: code snippets organized by practical use cases
* Url
* ...other helpers...
